<template>
  <div>

    <!-- TITLE SECTION -->

    <div class="section-title text-center py-3 py-md-5">
      Cadastro de usuário
    </div>

    <!-- USP BOND SECTION -->

    <b-form v-if="show" @submit="onSubmit">
      <b-card class="my-3" @input="clearError">
        <p class="text-center h3"> Login</p>
        <b-form-group id="email-do-usuario"
                      label="Email:"
                      label-for="email do usuario"
                      class="my-3">
          <b-form-input id="user_email"
                        v-model="form.user_email"
                        type="text"
                        required
                        placeholder="Email de identificação do sistema"/>
        </b-form-group>
        <b-form-group id="senha-do-usuario"
                      label="Senha:"
                      label-for="senha do usuario"
                      class="my-3">
          <b-form-input id="user_password"
                        v-model="form.password"
                        type="password"
                        required/>
        </b-form-group>
        <div class="submit-message">
          <b-card v-if="already_submit && !submit_success">
            <p style="font-size: 1em">
              {{ error_message }}
            </p>
          </b-card>
        </div>
      </b-card>
      <b-row>
        <b-col sm="12" md="4" offset-md="4">
          <b-button class="btn-block" type="submit" to="/cadastro/usuario">Cadastrar-se</b-button>
        </b-col>
        <b-col sm="12" md="4">
          <b-button class="btn-block" type="submit">Enviar</b-button>
        </b-col>
      </b-row>
    </b-form>

  </div>
</template>

<script>
export default {
  data() {
    return {
      error_message: "",
      submit_success: false,
      already_submit: false,
      form: {
        user_email: null,
        password: null
      },
      show: true
    };
  },
  methods: {
    onSubmit(evt) {
      evt.preventDefault();
      this.$store
        .dispatch("authenticateUser", {
          user_email: this.form.user_email,
          password: this.form.password
        })
        .then(() => {
          this.$router.push("/");
        })
        .catch(e => {
          console.log(e.response.data.message);
          this.error_message = e.response.data.message;
          this.submit_success = false;
          this.already_submit = true;
        });
    },
    clearError() {
      this.submit_success = this.already_submit = false;
      this.error_message = "";
    }
  }
};
</script>


<style>
.btn-block {
  margin-top: 1em;
  margin-bottom: 1em;
  background-color: #fcb421;
}

.btn-block:hover {
  background-color: #ecbb5b;
}

.section-title {
  font-size: 30px;
}
</style>
